models/Autores.php
<?php

namespace app\models;

use Yii;

/**
 * This is the model class for table "autores".
 *
 * @property int $id
 * @property string $nombre
 * @property string $foto
 *
 * @property Libros[] $libros
 */
class Autores extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'autores';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['nombre'], 'string', 'max' => 100],
            [['foto'], 'file', 'skipOnEmpty' => true, 'extensions' => 'png, jpg'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'nombre' => 'Nombre',
            'foto' => 'Foto',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getLibros()
    {
        return $this->hasMany(Libros::className(), ['autor' => 'id']);
    }
    
    public function upload(){
        $this->foto->saveAs('images/' . $this->foto->baseName . '.' . $this->foto->extension);
    }
}

controllers/AutoresController.php
<?php

namespace app\controllers;

use Yii;
use app\models\Autores;
use yii\data\ActiveDataProvider;
use yii\web\Controller;
use yii\web\NotFoundHttpException;
use yii\filters\VerbFilter;
use yii\web\UploadedFile;

/**
 * AutoresController implements the CRUD actions for Autores model.
 */
class AutoresController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }

    /**
     * Lists all Autores models.
     * @return mixed
     */
    public function actionIndex()
    {
        $dataProvider = new ActiveDataProvider([
            'query' => Autores::find(),
        ]);

        return $this->render('index', [
            'dataProvider' => $dataProvider,
        ]);
    }

    /**
     * Displays a single Autores model.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render('view', [
            'model' => $this->findModel($id),
        ]);
    }

    /**
     * Creates a new Autores model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Autores(); // crear objeto nuevo

        if ($model->load(Yii::$app->request->post())) {
            $model->foto = UploadedFile::getInstance($model, 'foto');
            if ($model->save()) {
                $model->upload();
                return $this->redirect(['view', 'id' => $model->id]);
            }
        }

        return $this->render('create', [
                    'model' => $model,
        ]);
    }
    
    

    /**
     * Updates an existing Autores model.
     * If update is successful, the browser will be redirected to the 'view' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
         
        if ($model->load(Yii::$app->request->post())) {
            // intentamos recuperar el fichero subido (actualizado)
            // en caso de que no seleccione ninguno el metodo estatico
            // devuelve null
            
            $puestoFoto=UploadedFile::getInstance($model, 'foto');
            if(is_null($puestoFoto)){
                // si no ha cogido ninguna foto cojo el valor anterior
                $model->foto=$model->getOldAttribute("foto");
            }else{
                $model->foto=$puestoFoto;
            }
            
            if ($model->save()) {
                // compruebo si hay que subir el archivo
                if(!is_null($puestoFoto)){
                    $model->upload();
                }
                return $this->redirect(['view', 'id' => $model->id]);
            }
        }
        
        return $this->render('update', [
            'model' => $model,
        ]);
    }

    /**
     * Deletes an existing Autores model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     * @param integer $id
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();

        return $this->redirect(['index']);
    }

    /**
     * Finds the Autores model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     * @param integer $id
     * @return Autores the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Autores::findOne($id)) !== null) {
            return $model;
        }

        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    public function actionListar(){
        $dataProvider = new ActiveDataProvider([
            'query' => Autores::find(),
            'pagination' => [
                'pageSize' => 1,
            ],
        ]);

        return $this->render('listar', [
            'dataProvider' => $dataProvider,
        ]);
    }
    
    public function actionObras($id){
        
        /*Autores::find()->joinWith("libros")
                ->where(['autor'=>$id]);*/
        
        
        $consulta=\app\models\Libros::find()->where(['autor'=>$id]);
        
       
        $dataProvider = new ActiveDataProvider([
            'query' => $consulta,
            'pagination' => [
                'pageSize' => 2,
            ],
        ]);
        
        // opcion 1
        $autor=Autores::find()->where(['id'=>$id])->one();

        // opcion 2
        /*$modelo=$dataProvider->query->all(); // saco el modelo desde la consulta del dataprovider
        $modelo=$dataProvider->models;   // saco el modelo desde el dataprovider
        if(is_null($modelo)){
            echo "no tengo obras";
            $autor=Autores::find()->where(['id'=>$id])->one();
        }else{
            $autor=$modelo[0]->autor0; 
        }*/
        
        
       
        return $this->render('obrasautor', [
            'dataProvider' => $dataProvider,
            'nombre'=>$autor->nombre,
        ]);
    }
}

views/autores/_form.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Autores */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="autores-form">

    <?php $form = ActiveForm::begin(); ?>

    <?= $form->field($model, 'nombre')->textInput(['maxlength' => true]) ?>

    <?= $form->field($model, 'foto')->fileInput() ?>

    <?php
    if (!is_null($model->foto)) {
        echo Html::img('@web/images/' . $model->foto, [
            'alt' => 'My logo',
            'width' => 800,
            'class' => 'img-responsive img-thumbnail'
        ]);
    }
    ?>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>

    <?php ActiveForm::end(); ?>

</div>

views/autores/_listar.php
<?php
use yii\helpers\Html;

?>

<h1>
    <?= $model->nombre; ?>
</h1>

<?= Html::img('@web/images/' . $model->foto, ['class' => 'img-responsive img-circle']) ?>

<?= Html::a('Obras de esta autor', ['autores/obras','id'=>$model->id], ['class' => 'btn btn-large btn-primary']); ?>

views/autores/create.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Autores */

$this->title = 'Create Autores';
$this->params['breadcrumbs'][] = ['label' => 'Autores', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="autores-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/autores/index.php
<?php

use yii\helpers\Html;
use yii\grid\GridView;

/* @var $this yii\web\View */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Autores';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="autores-index">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Create Autores', ['create'], ['class' => 'btn btn-success']) ?>
    </p>


    <?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            ['class' => 'yii\grid\SerialColumn'],

            'id',
            'nombre',
            'foto',

            ['class' => 'yii\grid\ActionColumn'],
        ],
    ]); ?>


</div>

views/autores/listar.php
<?php
use yii\widgets\ListView;

$this->params['breadcrumbs'][] = ['label' => 'Autores', 'url' => ['listar']];
$this->params['breadcrumbs'][]= ' Listado de Autores';
        
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
]);

views/autores/obrasautor.php
<?php

use yii\grid\GridView;

?>

<h1> <?= $nombre ?> </h1>

<?= GridView::widget([
        'dataProvider' => $dataProvider,
        'columns' => [
            'id',
            'nombre',
            'editorial',
            'autor',
            'portada',
        ],
    ]); 

?>

<div class="row">
    <div class="col-sm-12">
        <?= \yii\helpers\Html::a( 'Atras', Yii::$app->request->referrer,[
            'class'=>'btn btn-primary'
        ]);?>
    </div>
</div>

views/autores/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model app\models\Autores */

$this->title = 'Update Autores: ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Autores', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="autores-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

views/autores/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model app\models\Autores */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Autores', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
\yii\web\YiiAsset::register($this);
?>
<div class="autores-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'nombre',
            'foto',
        ],
    ]) ?>

</div>